package myTest1;

import java.util.Arrays;
import java.util.Scanner;

public class BinarySearch {

	// 이진 검색
	static int binarySearch(int[] array, int arrayLength, int searchValue){
		int first = 0;							// 검색 범위의 첫 인덱스
		int last = arrayLength-1;		// 검색 범위의 끝 인덱스
		
		do{
			int center = (first +  last) /2 ; // 중앙 요소의 인덱스
			if(array[center] == searchValue) 
				return center;	// 검색 성공
			else if(array[center] < searchValue) 
				first = center+1;	// 검색 범위를 뒤쪽 절반으로 좁힘
			else 
				 last = center -1;	// 검색 범위를 앞쪽 절반으로 좁힘
		}while(first <=  last);
		return -1;		// 검색 실패
	}
	
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		System.out.println("배열 길이 : ");
		int arrayLength = scanner.nextInt();
		int[] array = new int[arrayLength];	// 요솟수가 num인 배열
		System.out.println("오름차순으로 입력");
		
		System.out.print("array[0] : ");
		array[0] = scanner.nextInt();
		
		for(int i=1; i<arrayLength; i++){
			do{
				System.out.print("array[" + i + "] : ");
				array[i] = scanner.nextInt();
			}while(array[i] < array[i-1]);		// 바로 앞의 요소보다 작으면 다시 입력
		}
		
		System.out.println("검색할 값");	// 키 값을 입력
		int searchValue = scanner.nextInt();
		// 구현한 binarySearch 메소드 사용
		int idx = binarySearch(array, arrayLength, searchValue);		
		// Arrays.binarySearch 이진검색 표준라이브러리 사용
		int idx2 = Arrays.binarySearch(array, searchValue);
		
		if(idx == -1){
			System.out.println("구현한 이진검색 메소드 결과 그 값의 요소가 없습니다.");
		}else{
			System.out.println("구현한 이진검색 메소드 결과 "+searchValue+"은(는) array["+idx+"]에 있습니다.");
		}
		
		if(idx2 == -1){
			System.out.println("구현한 이진검색 메소드 결과 그 값의 요소가 없습니다.");
		}else{
			System.out.println("Arrays.binarySearch 표준 라이브러리 사용결과 "+searchValue+"은(는) array["+idx2+"]에 있습니다.");
		}
		
		
	}
}
