package myTest1;

import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class ConstructorBinarySearchLibrary {
	// 신체검사 데이터 정의
	static class PhyscData{
		private String name;	// 이름
		private int height;		// 키
		private double vision;	// 시력
		
		// 생성자
		public PhyscData(String name, int height, double vision){
			this.name = name; 
			this.height = height; 
			this.vision = vision;
		}
		
		// 문자열을 반환하는 메서드
		public String toString(){
			return name + " " + height + " " + vision;
		}
		
		public static final Comparator<PhyscData> HEIGHT_ORDER = new HeightOrderComparator();
		public static final Comparator<PhyscData> VISION_ORDER = new VisionOrderComparator();
		
		private static class HeightOrderComparator implements Comparator<PhyscData>{
			public int compare(PhyscData d1, PhyscData d2){
				return (d1.height > d2.height) ? 1:
							(d1.height < d2.height) ? -1 : 0;
			}
		}

		private static class VisionOrderComparator implements Comparator<PhyscData>{
			public int compare(PhyscData d1, PhyscData d2){
				return (d1.vision < d2.vision) ? 1:
					(d1.vision > d2.vision) ? -1 : 0;
			}
		}
	}
	
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		
		// 키 오름차순, 시력 내림차순 정렬
		PhyscData[] arrays = {
				new PhyscData("윤아", 160, 1.5),
				new PhyscData("태연", 161, 1.4),
				new PhyscData("티파니", 162, 1.3),
				new PhyscData("제시카", 163, 1.2),
				new PhyscData("유리", 164, 1.1),
				new PhyscData("서현", 165, 1.0),
				new PhyscData("써니", 166, 0.9),
		};
		
		System.out.print("몇 cm인 사람을 찾고 있나요? : ");
		int height = scanner.nextInt();
		int idx = Arrays.binarySearch(arrays, new PhyscData("", height, 0.0), PhyscData.HEIGHT_ORDER);
		if(idx < 0){
			System.out.println("요소가 없습니다.");
		}else{
			System.out.println("arrays[" + idx + "]에 있습니다.");
			System.out.println("찾은 데이터 : " + arrays[idx]);
		}
		
		System.out.println("시력이 몇인 사람을 찾나요?");
		double visionValue = scanner.nextDouble();
		int idx2 = Arrays.binarySearch(arrays, new PhyscData("", 0, visionValue), PhyscData.VISION_ORDER);
		if(idx2 < 0){
			System.out.println("요소가 없습니다.");
		}else{
			System.out.println("arrays[" + idx2 + "]에 있습니다.");
			System.out.println("찾은 데이터 : " + arrays[idx2]);
		}
	}
}
